%define ALD_Ver		2.0
%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

Name:		libvpx

License:	BSD
Summary:	WebM VP8/VP9 Codec

Version:	1.8.2
Release:	0

Source: %{name}-%{version}.tar.xz
Source2: %{name}-%{version}-patches.tgz

##http://downloads.webmproject.org/releases/webm/%{name}-%{version}.tar.bz2
#https://github.com/webmproject/libvpx/archive/v%{version}.tar.gz

%define DestDir		/Multimedia
# -----------------------------------------------------

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define _CROSS 0
%define MakeLocCross 0
%else
# rpm --target=armv7hl -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%define _host %{_arch}-%{_os}%{_gnu}
%endif

#------------------ CROSS DIR --------------------

%define docdir		%{_defaultdocdir}/%{name}

%if %{have_auto_local}
%define __os_install_post %{nil}
%define CrossPath	%(%{auto_local} -GetCrossPath -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu})
%endif

# ------------------- description ------------------------------------
%description
WebM VP8/VP9 Codec
#-------------------------------
%package utils
Summary:      VP8 utilities and tools
%description utils
A selection of utilities and tools for VP8
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
%description devel
These libraries are needed to compile C code.
#-------------------------------
%package %{_target_cpu}
Summary:      %{name} Cross-%{_target_cpu}
Buildarch:    noarch
autoreqprov:  0
%description %{_target_cpu}
%{name} Cross-%{_target_cpu}

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

tar -xaf %SOURCE2
#patch -p0<patches/libvpx-1.7.0-leave-fortify-source-on.patch

sed -i s:" ||  check_add_cflags -O3":: build/make/configure.sh

# ------------------- Build ------------------------------------------
%Build 
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i586 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -O2 -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables"

export CFLAGS="$OPTFLAGS -std=gnu99"
export CXXFLAGS="$OPTFLAGS"
LDFLAGS="-Wl,--gc-sections"


%if %{_CROSS}
CC=%{_host}-gcc
%else
CC=gcc
%endif

./configure \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--enable-shared \
	--enable-pic \
%if %{_arch} == "i386"
	--target=x86-linux-gcc \
%endif
%if %{_arch} == "x86_64"
	--target=x86_64-linux-gcc \
%endif
%if %{_arch} == "arm"
	--target=armv7-linux-gcc \
%endif
	--enable-vp9-decoder \
	--enable-vp9-encoder \
	--size-limit=8192x8192 \
	--disable-unit-tests \
	&>FConfigure_log.txt

#	--enable-install-srcs \
#	--enable-webm-io
#	--enable-experimental
#	--enable-vp9-highbitdepth

make V=1 &>FMake_log.txt

%if %{_CROSS}
CC=%{_host}-gcc
%else
CC=gcc
%endif

$CC -fPIC -shared -static-libgcc -Wl,--no-undefined \
	-Wl,--version-script,libvpx.ver \
	-Wl,-soname,libvpx.so.6 -o libvpx.so.6.2.0 \
	-Wl,--whole-archive \
	libvpx_g.a \
	-Wl,--no-whole-archive \
	-pthread -lm

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt
#make DIST_DIR=%{buildroot}%{_prefix} dist &>FInstall_log.txt

cp LICENSE AUTHORS $RPM_BUILD_ROOT%{docdir}/

rm $RPM_BUILD_ROOT%{_libdir}/libvpx.a

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -DelLocCrossDir=%{_bindir}
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%files
%{_libdir}/*.so.*
%{docdir}

%files utils
%{_bindir}

%files devel
%{_includedir}
%{_libdir}/*.so
%{_libdir}/pkgconfig

# ------------------- Cross Files ------------------------------------
%if %{MakeLocCross} && %{have_auto_local}

%files %{_target_cpu}
%{CrossPath}%{_libdir}
%{CrossPath}%{_includedir}
%{CrossPath}%{docdir}

%endif # MakeLocCross
